#include <bits/stdc++.h>

using namespace std;

int main() {
	
	long long int n,q,i,j,rez=0,brp=0,c;
	
	scanf("%lld %lld", &n,&q);
	
	long long d[n],p[n],b[q];
	
	for(i=0;i<n;i++){
		scanf("%lld",&d[i]);
		scanf("%lld",&p[i]);
	}
	
	for(j=0;j<q;j++){
		scanf("%lld",&b[j]);		
	}
	for(j=0,i=0;j<q;j++){
		c=b[j];
		while(c>0){

				if(b[j]==d[i]){
					brp=brp+p[i];
				}
			if(brp>0){
				rez++;
				brp--;
			}
			c--;
			i++;
		}
		
		cout<<rez;
	}

    return 0;
}